# Class NoteObserver < ActiveRecord::Observer

- app/observers/note_observer.rb

Methods

A
  - after_create
N
  - notify_team
S
  - send_notify_mails
T
  - team_without_note_author

Instance Public methods
after_create(note) Link

Source: show

    # File app/observers/note_observer.rb, line 3
    def after_create(note)
      send_notify_mails(note)
    end

Instance Protected methods
notify_team(note) Link

Notifies the whole team except the author of note

Source: show

    # File app/observers/note_observer.rb, line 22
    def notify_team(note)
      # Note: wall posts are not "attached" to anything, so fall back to "Wall"
      noteable_type = note.noteable_type.presence || "Wall"
      notify_method = "note_#{noteable_type.underscore}_email".to_sym

      if Notify.respond_to? notify_method
        team_without_note_author(note).map do |u|
          Notify.send(notify_method, u.id, note.id).deliver
        end
      end
    end

send_notify_mails(note) Link

Source: show

    # File app/observers/note_observer.rb, line 9
    def send_notify_mails(note)
      if note.notify
        notify_team(note)
      elsif note.notify_author
        # Notify only author of resource
        Notify.note_commit_email(note.commit_author.id, note.id).deliver
      else
        # Otherwise ignore it
        nil
      end
    end

team_without_note_author(note) Link

Source: show

    # File app/observers/note_observer.rb, line 34
    def team_without_note_author(note)
      note.project.users.reject { |u| u.id == note.author.id }
    end